#!/usr/bin/env node
import r from "chalk";
import m from "node:path";
import u from "node:fs";
import I from "json5";
import E from "lodash.upperfirst";
import y from "lodash.camelcase";
import x from "lodash.kebabcase";
import L from "lodash.lowerfirst";
import d from "lodash.template";
import S from "prompts";
import { OutputModeEnum as $, handler as C } from "@done-coding/cli-template";
import k from "yargs";
import { hideBin as T } from "yargs/helpers";
import D from "lodash.curry";
var i = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(i || {});
const _ = (e, n) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return console.log(r.red("组件名只能包含字母、数字、中划线")), process.exit(1);
  const { nameExcludes: t } = n;
  return t.includes(e) ? (console.log(
    r.red(`组件名: ${e}是保留名称。
保留名称: ${t.join(",")}`)
  ), process.exit(1)) : !0;
}, f = {
  version: "0.2.1",
  name: "@done-coding/cli-component",
  description: "组件命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: j, moduleName: A } = f.cliConfig, w = () => m.resolve(j, A), M = () => ({
  execDir: process.cwd(),
  templateDir: w()
}), g = (e) => {
  const { series: n, name: t } = e, s = E(y(t)), c = L(s), a = x(s), l = n ? E(y(n)) : "", o = l ? `${l}${s}` : "", p = x(o);
  return {
    series: l,
    name: s,
    nameLowerFirst: c,
    nameKebab: a,
    fullName: o,
    fullNameKebab: p,
    cls: p
  };
}, F = (e) => ({
  $: "$",
  ...M(),
  ...g(e)
}), h = () => {
  const e = m.resolve(w(), "index.json");
  if (!u.existsSync(e))
    return console.log(r.red(`模块入口文件不存在: ${e}`)), process.exit(1);
  const t = JSON.parse(u.readFileSync(e, "utf-8")).config;
  if (!t)
    return console.log(r.red(`配置文件相对路径不存在: ${t}`)), process.exit(1);
  const s = m.resolve(
    m.dirname(e),
    t
  );
  if (!u.existsSync(s))
    return console.log(r.red(`配置文件不存在: ${s}`)), process.exit(1);
  const c = I.parse(u.readFileSync(s, "utf-8")), a = M();
  return c.componentDir = d(c.componentDir)(a), c;
}, v = (e) => {
  const { componentDir: n, nameExcludes: t } = e;
  return u.statSync(n).isDirectory() ? u.readdirSync(n).map((l) => {
    const o = m.join(n, l);
    return u.statSync(o).isDirectory() ? (console.log("filePath:", o, m.basename(o)), m.basename(o)) : "";
  }).filter((l) => !(!l || t.includes(l))) : (console.log(r.red("组件源码路径不是目录")), process.exit(1));
}, K = async () => {
  console.log(r.blue("展示列表"));
  const e = h(), n = v(e);
  console.table(
    n.map((t) => {
      const { name: s, fullName: c } = g({
        ...e,
        name: t
      });
      return {
        [r.green("名称")]: s,
        [r.green("带系列名称")]: c,
        [r.green("绝对路径")]: m.resolve(e.componentDir, t)
      };
    })
  );
}, N = async ({
  name: e,
  config: n,
  command: t
}) => {
  if (![i.ADD, i.REMOVE].includes(t))
    return console.log(r.red(`不支持组件${t}操作`)), process.exit(1);
  const s = F({
    ...n,
    name: e
  }), c = JSON.stringify(s);
  for (const { entry: a, index: l } of n.list) {
    if (a) {
      const o = a;
      o != null && o.input && (o.input = d(o.input)(s)), o != null && o.output && (o.output = d(o.output)(s));
      const p = {
        ...a,
        envData: c,
        mode: $.APPEND,
        rollback: t === i.REMOVE,
        dealMarkdown: !0
      };
      await C(p);
    }
    if (l) {
      const o = l;
      o != null && o.input && (o.input = d(o.input)(s)), o != null && o.output && (o.output = d(o.output)(s));
      const p = {
        ...l,
        envData: c,
        mode: $.OVERWRITE,
        rollback: t === i.REMOVE,
        dealMarkdown: !0
      };
      await C(p);
    }
  }
}, U = async ({ name: e }) => {
  console.log(r.blue("添加组件"));
  let n;
  e ? n = e : n = (await S({
    type: "text",
    name: "name",
    message: "请输入组件名"
  })).name;
  const t = h();
  _(n, t);
  const { series: s } = t, c = await v(t);
  for (let a of c)
    if (g({
      series: s,
      name: n
    }).nameKebab === a)
      return console.log(r.red(`组件${a}已存在, 不能再次创建${n}组件`)), process.exit(1);
  return N({
    name: n,
    config: t,
    command: i.ADD
  });
}, z = async ({ name: e }) => {
  console.log(r.blue("移除组件"));
  const n = h(), t = await v(n);
  if (t.length === 0)
    return console.log(r.red("组件列表为空")), process.exit(1);
  let s;
  e ? s = e : s = (await S({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: t.map((a) => ({ title: a, value: a }))
  })).name;
  const { series: c } = n;
  for (let a of t)
    if (g({
      series: c,
      name: s
    }).nameKebab === a) {
      await N({
        name: s,
        config: n,
        command: i.REMOVE
      }), u.rmdirSync(m.resolve(n.componentDir, a));
      return;
    }
  return console.log(r.red(`组件${s}不存在`)), process.exit(1);
}, b = async (e, n) => (console.log("com", n), e === i.ADD ? U(n) : e === i.REMOVE ? z(n) : e === i.LIST ? K() : (console.log(r.red(`无效的命令: ${e}`)), process.exit(1))), R = async (e) => {
}, P = f.cliConfig.moduleName, H = (e, n) => {
  console.log(e ? r.red(e) : r.red(n.message)), process.exit(1);
}, J = f.description, Z = `Usage: $0 ${P} <command> [options]`, B = "Usage: $0 <command> [options]", O = (e) => e.command({
  command: `${i.ADD} <name>`,
  describe: "新增一个组件",
  builder: (n) => n.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  handler: D(b)(i.ADD)
}).command({
  command: `${i.REMOVE} [name]`,
  describe: "删除一个组件",
  builder: (n) => n.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  handler: D(b)(i.REMOVE)
}).command({
  command: i.LIST,
  describe: "展示组件列表",
  handler: D(b)(i.LIST)
}).demandCommand(1), V = (e, n = !1) => n ? O(e.strict().usage(Z)) : O(
  e.strict().usage(B).help("help").version(f.version).alias("v", "version").alias("h", "help")
).fail(H).argv, W = (e) => V(e, !0), me = {
  command: P,
  describe: J,
  builder: W,
  handler: R
}, ue = async () => {
  const e = k(T(process.argv));
  return await V(e), R();
};
export {
  me as a,
  ue as c,
  R as h
};
