import type { Config, Options } from "./types";
/** 获取模板目录绝对路径 */
export declare const getTemplateDirAbsolutePath: () => string;
/** 路径环境变量 */
export interface PathEnvData {
    /** 执行命令的目录绝对路径 */
    execDir: string;
    /** 模板目录绝对路径 */
    templateDir: string;
}
/** 获取路径环境变量 */
export declare const getPathEnvData: () => {
    execDir: string;
    templateDir: string;
};
/** 组件环境变量 */
export interface ComponentEnvData {
    /** 矫正后的组件系列 */
    series: string;
    /** 矫正后的组件名 */
    name: string;
    /** 矫正后的组件名小写开头 */
    nameLowerFirst: string;
    /** 小写连接的组件名 */
    nameKebab: string;
    /** 矫正后的带系列组件名 */
    fullName: string;
    /** 矫正后的带系列小写连接的组件名 */
    fullNameKebab: string;
    /** 组件类名 */
    cls: string;
}
/** 获取环境变量 */
export declare const getComponentEnvData: (data: Pick<Config, "series"> & Required<Options>) => ComponentEnvData;
/** 环境变量 */
export interface EnvData extends PathEnvData, ComponentEnvData {
    /** 转义的$ */
    $: "$";
}
/** 获取环境变量 */
export declare const getEnvData: (data: Pick<Config, "series"> & Required<Options>) => EnvData;
